#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>

int main(int argc, char *argv[])
{
	struct addrinfo hints;
	struct addrinfo *res;
	int e;
	const char *host = "sip.covert.org";
	const char *port = NULL;

	memset(&hints, 0, sizeof(hints));
	hints.ai_socktype = SOCK_DGRAM;

#ifdef AI_NUMERICSERV
	hints.ai_flags = AI_NUMERICHOST | AI_NUMERICSERV;
	printf("AI_NUMERICSERV\n");
#else
	hints.ai_flags = AI_NUMERICHOST;
	printf("!AI_NUMERICSERV\n");
#endif

	if ((e = getaddrinfo(host, port, &hints, &res))) {
		switch (e) {
		case EAI_AGAIN:
			fprintf(stderr, "EAI_AGAIN: ");
			break;
		case EAI_BADFLAGS:
			fprintf(stderr, "EAI_BADFLAGS: ");
			break;
		case EAI_BADHINTS:
			fprintf(stderr, "EAI_BADHINTS: ");
			break;
		case EAI_FAIL:
			fprintf(stderr, "EAI_FAIL: ");
			break;
		case EAI_FAMILY:
			fprintf(stderr, "EAI_FAMILY: ");
			break;
		case EAI_MEMORY:
			fprintf(stderr, "EAI_MEMORY: ");
			break;
		case EAI_NONAME:
			fprintf(stderr, "EAI_NONAME: ");
			break;
		case EAI_PROTOCOL:
			fprintf(stderr, "EAI_PROTOCOL: ");
			break;
		case EAI_SERVICE:
			fprintf(stderr, "EAI_SERVICE: ");
			break;
		case EAI_SOCKTYPE:
			fprintf(stderr, "EAI_SOCKTYPE: ");
			break;
		case EAI_SYSTEM:
		default:
			fprintf(stderr, "EAI_SYSTEM: (%s): ", strerror(errno));
			break;
		}

		fprintf(stderr, "getaddrinfo(\"%s\", \"%s\", ...): %s\n",
			host,
			port ? port : "(null)",
			gai_strerror(e));
	}

	return 0;
}
